﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using IDTechSDK;

namespace USDKDemo
{
    public partial class Decrypt : Form
    {
        public Decrypt()
        {
            InitializeComponent();
        }

        private void removeAllSpaces()
        {
            tBDK.Text = tBDK.Text.Replace(" ", String.Empty);
            comp1.Text = comp1.Text.Replace(" ", String.Empty);
            comp2.Text = comp2.Text.Replace(" ", String.Empty);
            comp3.Text = comp3.Text.Replace(" ", String.Empty);
            tbIPEK.Text = tbIPEK.Text.Replace(" ", String.Empty);
            tKSN.Text = tKSN.Text.Replace(" ", String.Empty);
            tbPAN.Text = tbPAN.Text.Replace(" ", String.Empty);
            tEncryptedData.Text = tEncryptedData.Text.Replace(" ", String.Empty);
            tBDKpin.Text = tBDKpin.Text.Replace(" ", String.Empty);
            tKSNpin.Text = tKSNpin.Text.Replace(" ", String.Empty);
            tbPANpin.Text = tbPANpin.Text.Replace(" ", String.Empty);
            tEncryptedDatapin.Text = tEncryptedDatapin.Text.Replace(" ", String.Empty);
            tBDKdata.Text = tBDKdata.Text.Replace(" ", String.Empty);
            tKSNdata.Text = tKSNdata.Text.Replace(" ", String.Empty);
            tEncryptedDatadata.Text = tEncryptedDatadata.Text.Replace(" ", String.Empty);

        }

        private void button1_Click(object sender, EventArgs e)
        {
            removeAllSpaces();
            if ((tBDK.Text.Length + tbIPEK.Text.Length) != 32)
            {
                tResults.Text = "BDK or IPEK Error.  Provide a BDK or IPEK, and make sure they are 16 bytes (32 characters)";
                return;
            }

            if (tKSN.Text.Length == 0)
            {
                tResults.Text = "Missing KSN";
                return;
            }
            if (tdes.Checked)
            {
                if (tKSN.Text.Length > 20)
                {
                    tResults.Text = "KSN too large";
                    return;
                }
            }
            else
            {
                if ((tKSN.Text.Length != 20) && (tKSN.Text.Length != 24))
                {
                    tResults.Text = "KSN Error, make sure it is 10 bytes (20 characters) or 12 bytes (24 characters)";
                    return;
                }
            }
            if ((tKSN.Text.Length % 2) == 1)
            {
                tResults.Text = "KSN incorrect";
                return;
            }
            if (tbPAN.Text.Length > 0 && (tbPAN.Text.Length < 12 || tbPAN.Text.Length > 19))
            {
                tResults.Text = "Please enter valid PAN between 12 and 19 digits";
                return;
            }
            if (tbPAN.Text.Length > 0 && rbEncrypt.Checked && (tbASCII.Text.Length == 0 || tbASCII.Text.Length > 14))
            {
                tResults.Text = "Please enter valid PIN to encrypt, between 1 and 14 digits";
                return;
            }

            //AES-DUPKT Decrypt
            if ((!tdes.Checked) && (tKSN.Text.Length == 24) && (rbDecrypt.Checked))
            {
                string KSN = tKSN.Text;
                string Key = tBDK.Text;
                string PAN = tbPAN.Text;
                string EncipheredPin = tEncryptedData.Text;
                //int a_Keymanagement:
                //                    1, TDES Key Management
                //                    2, AES  Key Management
                //int a_EncryptMode:
                //                    1, TDES
                //                    2, AES
                string strResp = AES_DUPKT_PIN_Decrypt(1, 2, KSN, Key, PAN, EncipheredPin);
                if (!string.IsNullOrEmpty(strResp))
                {
                    byte[] bytePin = Common.getByteArray(strResp);
                    int kLen = bytePin[0] & 0x0F;
                    string strPin = strResp.Substring(2, kLen);
                    tResults.Text = string.Concat("PIN = ", strPin, "\r\n", "Whole PIN Block = ", strResp);
                }
                else
                {
                    tResults.Text = "PIN decrypt failed!";
                }
                return;
            }

            IDTCryptoData data = new IDTCryptoData();
            data.isTDES = (tdes.Checked);
            data.isDecryption = (rbDecrypt.Checked);
            data.MAC_Command = rbMacCode.Checked;
            if (rbData.Checked)
                data.keyVariant = 0;
            else if (rbPIN.Checked)
                data.keyVariant = 1;
            else
                data.keyVariant = 2;
            if (tdes.Checked)
            {
                if (rbType3.Checked) data.PINBlockType = 3;
            }
            else
            {
                data.PINBlockType = 4;
            }
            /*
            int klen2 = 10;
            if (!data.isTDES) klen2 = 12;
            data.KSN = new byte[klen2];
            for (int x = 0; x < data.KSN.Length; x++) data.KSN[x] = 0xff;
            byte[] dataKSN = Common.getByteArray(tKSN.Text);
            int offset = klen2 - dataKSN.Length;
            System.Array.Copy(dataKSN, 0, data.KSN, offset, dataKSN.Length);
            */
            data.KSN = Common.getByteArray(tKSN.Text);

            data.BDK = Common.getByteArray(tBDK.Text);
            data.IPEK = Common.getByteArray(tbIPEK.Text);
            data.PAN = tbPAN.Text;
            data.dataToProcess = Common.getByteArray(tEncryptedData.Text);

            if (data.PAN != null && data.PAN.Length > 0 && data.isDecryption && !data.MAC_Command)
            {
                if (data.dataToProcess.Length != 8 && data.isTDES)
                {
                    tResults.Text = "PIN Block must be 8 bytes";
                    return;
                }
                else if (data.dataToProcess.Length != 16 && !data.isTDES)
                {
                    tResults.Text = "PIN Block must be 16 bytes";
                    return;
                }

                if (data.isTDES)
                {
                    data.pinBlock = new byte[8];
                    System.Array.Copy(data.dataToProcess, data.pinBlock, 8);
                }
                else
                {
                    data.pinBlock = new byte[16];
                    System.Array.Copy(data.dataToProcess, data.pinBlock, 16);
                }
            }

            if (!data.isDecryption && rbASCII.Checked) data.dataToProcess = Encoding.ASCII.GetBytes(tbASCII.Text);
            if (data.MAC_Command || rbHex.Checked)
            {
                tbASCII.Text = tbASCII.Text.Replace(" ", String.Empty);
                if (tbASCII.Text.Length < 2)
                {
                    tResults.Text = "Please provide data to MAC";
                    return;
                }
                data.dataToProcess = Common.getByteArray(tbASCII.Text);
            }

            if (Common.processDUKPT(ref data))
            {

                if (data.PAN != null && data.PAN.Length > 0)
                {
                    if (data.isDecryption)
                    {
                        tResults.Text = "PIN = " + data.PIN;
                    }
                    else
                    {
                        tResults.Text = "PIN Block= " + Common.getHexStringFromBytes(data.pinBlock);

                    }
                }
                else
                {
                    if (data.MAC_Command){
                        tResults.Text = "MAC Value is: " + Common.getHexStringFromBytes(data.dataResults) + "\r\n\r\n";

                    }
                    else
                    {
                        tResults.Text = Common.getHexStringFromBytes(data.dataResults) + "\r\n\r\n" + System.Text.Encoding.UTF8.GetString(data.dataResults);

                    }
                }
            }
            else
            {
                tResults.Text = "Could Not Process Request. Please verify data is complete.";
            }
            if (data.errorString != null && data.errorString.Length > 0)
            {
                tResults.Text = "Error Encountered: " + data.errorString;
                return;
            }

            tResults.Text = tResults.Text +
    "\r\n\r\n           IPEK:  " + Common.getHexStringFromBytes(data.IPEK)
      + "\r\n    Derived Key:  " + Common.getHexStringFromBytes(data.DEK)
      + "\r\n   Data Variant:  " + Common.getHexStringFromBytes(data.DataVariant)
      + "\r\n    PIN Variant:  " + Common.getHexStringFromBytes(data.PINVariant)
      + "\r\n    MAC Variant:  " + Common.getHexStringFromBytes(data.MACVariant);
            if (data.PAN != null && data.PAN.Length > 0)
            {
                tResults.Text = tResults.Text +
    "\r\n\r\n       PIN Block:  " + Common.getHexStringFromBytes(data.pinBlock)
      + "\r\n Clear PIN Block:  " + Common.getHexStringFromBytes(data.clearPinBlock)
      + "\r\n             PAN:  " + data.PAN
      + "\r\n             PIN:  " + data.PIN
      + "\r\n       FINAL PAN:  " + Common.getHexStringFromBytes(data.finalPAN);
            }
        }
        private void button2_Click(object sender, EventArgs e)
        {
            removeAllSpaces();
            if (tBDKdata.Text.Length != 32)
            {
                tResults.Text = "BDK  Error.  Provide a BDK, and make sure they are 16 bytes (32 characters)";
                return;
            }
            if (tKSNdata.Text.Length == 0)
            {
                tResults.Text = "Missing KSN";
                return;
            }
            if (tKSNdata.Text.Length > 20 && tdesdata.Checked)
            {
                tResults.Text = "KSN too large";
                return;
            }
            if (tKSNdata.Text.Length > 24 && !tdesdata.Checked)
            {
                tResults.Text = "KSN too large";
                return;
            }
            if ((tKSNdata.Text.Length % 2) == 1)
            {
                tResults.Text = "KSN incorrect";
                return;
            }




            IDTCryptoData data = new IDTCryptoData();
            data.isTDES = (tdesdata.Checked);
            data.isDecryption = true;

            data.keyVariant = 0;
            /*
            int ksnLen = 10;
            if (!data.isTDES) ksnLen = 12;

            data.KSN = new byte[ksnLen];
            for (int x = 0; x < data.KSN.Length; x++) data.KSN[x] = 0xff;
            byte[] dataKSN = Common.getByteArray(tKSNdata.Text);
            int offset = ksnLen - dataKSN.Length;
            System.Array.Copy(dataKSN, 0, data.KSN, offset, dataKSN.Length);
            */
            data.KSN = Common.getByteArray(tKSNdata.Text);

            data.BDK = Common.getByteArray(tBDKdata.Text);
            data.dataToProcess = Common.getByteArray(tEncryptedDatadata.Text);



            if (Common.processDUKPT(ref data))
            {


                tResults.Text = Common.getHexStringFromBytes(data.dataResults) + "\r\n\r\n" + System.Text.Encoding.UTF8.GetString(data.dataResults);



            }
            else
            {
                tResults.Text = "Could Not Process Request. Please verify data is complete.";
            }

            if (data.errorString != null && data.errorString.Length > 0)
            {
                tResults.Text = "Error Encountered: " + data.errorString;
                return;
            }

            tResults.Text = tResults.Text +
    "\r\n\r\n           IPEK:  " + Common.getHexStringFromBytes(data.IPEK)
      + "\r\n    Derived Key:  " + Common.getHexStringFromBytes(data.DEK)
      + "\r\n   Data Variant:  " + Common.getHexStringFromBytes(data.DataVariant)
      + "\r\n    PIN Variant:  " + Common.getHexStringFromBytes(data.PINVariant)
      + "\r\n    MAC Variant:  " + Common.getHexStringFromBytes(data.MACVariant);

        }

        private void button3_Click(object sender, EventArgs e)
        {
            removeAllSpaces();
            if (tBDKpin.Text.Length != 32)
            {
               if (dukpt.Checked) tResults.Text = "BDK  Error.  Provide a BDK, and make sure they are 16 bytes (32 characters)";
               else tResults.Text = "Base Key  Error.  Provide a Base Key, and make sure they are 16 bytes (32 characters)";
                return;
            }
            if (tKSNpin.Text.Length == 0 && dukpt.Checked)
            {
                tResults.Text = "Missing KSN";
                return;
            }
            if (tKSNpin.Text.Length > 20 && dukpt.Checked && tdespin.Checked)
            {
                tResults.Text = "KSN too large";
                return;
            }
            if (tKSNpin.Text.Length > 24 && dukpt.Checked && !tdespin.Checked)
            {
                tResults.Text = "KSN too large";
                return;
            }
            if ((tKSNpin.Text.Length % 2) == 1 && dukpt.Checked)
            {
                tResults.Text = "KSN incorrect";
                return;
            }
            if (tbPANpin.Text.Length < 12 || tbPANpin.Text.Length > 19)
            {
                tResults.Text = "Please enter valid PAN between 12 and 19 digits";
                return;
            }

          
            if (mksk.Checked)
            {
                byte[] pinData = null;
                pinData = Common.getByteArray(tEncryptedDatapin.Text);
                
                byte[] val = MKSKDecryptTDES(tBDKpin.Text, tbPANpin.Text, pinData);
                if (val != null && val.Length > 1)
                {
                    try
                    {
                        string PB = Common.getHexStringFromBytes(val);
                        string PIN = PB.Substring(2, val[0]);

                        tResults.Text = "PIN = " + PIN + "\r\n" + "Whole PIN Block = " + PB;
                    }
                    catch
                    {
                        tResults.Text = "Could not decrypt PIN";
                    }
                    

                }
                else
                {
                    tResults.Text = "Could not decrypt PIN";
                }
                return;
            }

            IDTCryptoData data = new IDTCryptoData();
            data.isTDES = (tdespin.Checked);
            data.isDecryption = true;

            data.keyVariant = 1;

            if (tdespin.Checked)
            {
                data.PINBlockType = 0;
            }
            else
            {
                string KSN = tKSNpin.Text;
                string Key = tBDKpin.Text;
                string PAN = tbPANpin.Text;
                string EncipheredPin = tEncryptedDatapin.Text;
                //int a_Keymanagement:
                //                    1, TDES Key Management
                //                    2, AES  Key Management
                //int a_EncryptMode:
                //                    1, TDES
                //                    2, AES
                string strResp = AES_DUPKT_PIN_Decrypt(1, 2, KSN, Key, PAN, EncipheredPin);
                if (!string.IsNullOrEmpty(strResp))
                {
                    byte[] bytePin = Common.getByteArray(strResp);
                    int kLen2 = bytePin[0] & 0x0F;
                    string strPin = strResp.Substring(2, kLen2);
                    tResults.Text = string.Concat("PIN = ", strPin, "\r\n", "Whole PIN Block = ", strResp);
                }
                else
                {
                    tResults.Text = "PIN decrypt failed!";
                }
                return;
                // data.PINBlockType = 4;
            }
            int kLen = 10;
            if (!data.isTDES) kLen = 12;
            data.KSN = new byte[kLen];
            for (int x = 0; x < data.KSN.Length; x++) data.KSN[x] = 0xff;
            byte[] dataKSN = Common.getByteArray(tKSNpin.Text);
            int offset = kLen - dataKSN.Length;
            System.Array.Copy(dataKSN, 0, data.KSN, offset, dataKSN.Length); data.BDK = Common.getByteArray(tBDKpin.Text);
            data.PAN = tbPANpin.Text;
            data.dataToProcess = Common.getByteArray(tEncryptedDatapin.Text);
           

            if (data.PAN != null && data.PAN.Length > 0 && data.isDecryption)
            {
                if (data.dataToProcess.Length != 8 && data.isTDES)
                {
                    tResults.Text = "PIN Block must be 8 bytes";
                    return;
                }
                else if (data.dataToProcess.Length != 16 && !data.isTDES)
                {
                    tResults.Text = "PIN Block must be 16 bytes";
                    return;
                }

                if (data.isTDES)
                {
                    data.pinBlock = new byte[8];
                    System.Array.Copy(data.dataToProcess, data.pinBlock, 8);
                }
                else
                {
                    data.pinBlock = new byte[16];
                    System.Array.Copy(data.dataToProcess, data.pinBlock, 16);
                }
            }


            if (Common.processDUKPT(ref data))
            {



                tResults.Text = "PIN = " + data.PIN;





            }
            else
            {
                tResults.Text = "Could Not Process Request. Please verify data is complete.";
            }

            if (data.errorString != null && data.errorString.Length > 0)
            {
                tResults.Text = "Error Encountered: " + data.errorString;
                return;
            }

            tResults.Text = tResults.Text +
    "\r\n\r\n           IPEK:  " + Common.getHexStringFromBytes(data.IPEK)
      + "\r\n    Derived Key:  " + Common.getHexStringFromBytes(data.DEK)
      + "\r\n   Data Variant:  " + Common.getHexStringFromBytes(data.DataVariant)
      + "\r\n    PIN Variant:  " + Common.getHexStringFromBytes(data.PINVariant)
      + "\r\n    MAC Variant:  " + Common.getHexStringFromBytes(data.MACVariant);
            if (data.PAN != null && data.PAN.Length > 0)
            {
                tResults.Text = tResults.Text +
    "\r\n\r\n       PIN Block:  " + Common.getHexStringFromBytes(data.pinBlock)
      + "\r\n Clear PIN Block:  " + Common.getHexStringFromBytes(data.clearPinBlock)
      + "\r\n             PAN:  " + data.PAN
      + "\r\n             PIN:  " + data.PIN
      + "\r\n       FINAL PAN:  " + Common.getHexStringFromBytes(data.finalPAN);
            }

        }
        private void tdes_CheckedChanged(object sender, EventArgs e)
        {
            panelPINBlock.Visible = tdes.Checked;
        }

        private void button4_Click(object sender, EventArgs e)
        {
            if (comp1.Text.Length  != 32)
            {
                tResults.Text = "Key Component 1 must be 16 bytes (32 characters)";
                return;
            }
            if (comp2.Text.Length != 32)
            {
                tResults.Text = "Key Component 2 must be 16 bytes (32 characters)";
                return;
            }
            if (comp3.Text.Length != 32 && comp3.Text.Length > 0 )
            {
                tResults.Text = "Key Component 3 must be 16 bytes (32 characters) or empty";
                return;
            }
            byte[] compk1 = Common.getByteArray(comp1.Text);
            byte[] compk2 = Common.getByteArray(comp2.Text);
            byte[] compk3 = null;
            kcv1.Text = Common.getHexStringFromBytes(Common.getKCV(compk1));
            kcv2.Text = Common.getHexStringFromBytes(Common.getKCV(compk2));
            if (comp3.Text.Length == 32)
            {
                compk3 = Common.getByteArray(comp3.Text);
                kcv3.Text = Common.getHexStringFromBytes(Common.getKCV(compk3));
            }
            byte[] results = Common.getBDKFromComponents(compk1, compk2, compk3);
            byte[] bdkkcv = Common.getKCV(results);

            if (comp3.Text.Length == 32)
            {
                tResults.Text =
"\r\n\r\n        BDK:  " + Common.getHexStringFromBytes(results)
+ "\r\n    BDK KCV:  " + Common.getHexStringFromBytes(bdkkcv)
+ "\r\n\r\n      KEY 1:  " + comp1.Text
+ "\r\n   KEY1 KCV:  " + kcv1.Text
+ "\r\n\r\n      KEY 2:  " + comp2.Text
+ "\r\n   KEY2 KCV:  " + kcv2.Text
+ "\r\n\r\n      KEY 3:  " + comp3.Text
+ "\r\n   KEY3 KCV:  " + kcv3.Text;
            }
            else
            {
                tResults.Text =
"\r\n\r\n        BDK:  " + Common.getHexStringFromBytes(results)
+ "\r\n    BDK KCV:  " + Common.getHexStringFromBytes(bdkkcv)
+ "\r\n\r\n      KEY 1:  " + comp1.Text
+ "\r\n   KEY1 KCV:  " + kcv1.Text
+ "\r\n\r\n      KEY 2:  " + comp2.Text
+ "\r\n   KEY2 KCV:  " + kcv2.Text;
            }

        }

        private void button5_Click(object sender, EventArgs e)
        {
            if (theBDK.Text.Length != 32)
            {
                tResults.Text = "BDK must be 16 bytes (32 characters)";
                return;
            }
            byte[] kBDK = Common.getByteArray(theBDK.Text);
            kcv4.Text = Common.getHexStringFromBytes(Common.getKCV(kBDK));


            byte[] compk1 = null;
            byte[] compk2 = null;
            byte[] compk3 = null;

            bool val = Common.getComponentsFromBDK(key3.Checked, kBDK, ref compk1, ref compk2, ref compk3);

            if (!val)
            {
                tResults.Text = "FAILED GENERATING KEYS";
                return;
            }
            byte[] compk1k = Common.getKCV(compk1);
            byte[] compk2k = Common.getKCV(compk2);


            if (key3.Checked)
            {
                byte[] compk3k = Common.getKCV(compk3);
                tResults.Text =
          "\r\n\r\n        BDK:  " + theBDK.Text
            + "\r\n    BDK KCV:  " + kcv4.Text
       + "\r\n\r\n      KEY 1:  " + Common.getHexStringFromBytes(compk1)
            + "\r\n   KEY1 KCV:  " + Common.getHexStringFromBytes(compk1k)
      + "\r\n\r\n      KEY 2:  " + Common.getHexStringFromBytes(compk2)
            + "\r\n   KEY2 KCV:  " + Common.getHexStringFromBytes(compk2k)
      + "\r\n\r\n      KEY 3:  " + Common.getHexStringFromBytes(compk3)
            + "\r\n   KEY3 KCV:  " + Common.getHexStringFromBytes(compk3k);

            }
            else
            {

                tResults.Text =
"\r\n\r\n        BDK:  " + theBDK.Text
+ "\r\n    BDK KCV:  " + kcv4.Text
+ "\r\n\r\n      KEY 1:  " + Common.getHexStringFromBytes(compk1)
+ "\r\n   KEY1 KCV:  " + Common.getHexStringFromBytes(compk1k)
+ "\r\n\r\n      KEY 2:  " + Common.getHexStringFromBytes(compk2)
+ "\r\n   KEY2 KCV:  " + Common.getHexStringFromBytes(compk2k);

            }
        }

        private void comp1_TextChanged(object sender, EventArgs e)
        {
            if (comp1.Text.Trim().Length == 32)
            {
                kcv1.Text = Common.getHexStringFromBytes(Common.getKCV(Common.getByteArray(comp1.Text)));

            }
            else kcv1.Text = "000000";
        }

        private void comp2_TextChanged(object sender, EventArgs e)
        {
            if (comp2.Text.Trim().Length == 32)
            {
                kcv2.Text = Common.getHexStringFromBytes(Common.getKCV(Common.getByteArray(comp2.Text)));

            }
            else kcv2.Text = "000000";
        }

        private void comp3_TextChanged(object sender, EventArgs e)
        {
            if (comp3.Text.Trim().Length == 32)
            {
                kcv3.Text = Common.getHexStringFromBytes(Common.getKCV(Common.getByteArray(comp3.Text)));

            }
            else kcv3.Text = "000000";
        }

        private void theBDK_TextChanged(object sender, EventArgs e)
        {
            if (theBDK.Text.Trim().Length == 32)
            {
                kcv4.Text = Common.getHexStringFromBytes(Common.getKCV(Common.getByteArray(theBDK.Text)));

            }
            else kcv4.Text = "000000";
        }

        private void tdes_CheckedChanged_1(object sender, EventArgs e)
        {
            panelPINBlock.Visible = tdes.Checked;
        }

        [DllImport("DecryptDLL.dll")]
        public static extern byte MKSKDecryptTDES(char[] m_BaseKey, char[] Accountstr, int EncryptPINLen, byte[] EPIN, byte[] ClearPIN);

        public static byte[] MKSKDecryptTDES(string sm_BaseKey, string sAccountstr, byte[] sEPIN)
        {
            char[] charArray = sm_BaseKey.ToCharArray();
            char[] chrArray = sAccountstr.ToCharArray();

            byte[] clearPIN = new byte[8];
            if (MKSKDecryptTDES(charArray, chrArray, sEPIN.Length, sEPIN, clearPIN) == 1)
            {
                return clearPIN;
            }
            return null;
        }


        [DllImport("DecryptDLL.dll")]
        public static extern Boolean AES_DUPKT_PIN_Block_Decipher(int a_Keymanagement, int a_EncryptMode, byte[] a_KSN, int a_LenKSN, byte[] a_Key, int a_LenKey, byte[] a_PAN, int a_LenPAN, byte[] a_EncipheredPin, int a_LenEncipheredPin, byte[] a_DeciperedPin, ref int a_LenDeciperedPin);

        //int a_Keymanagement:
        //                        1, TDES Key Management
        //                        2, AES  Key Management
        //int a_EncryptMode:
        //                        1, TDES 
        //                        2, AES  
        public static string AES_DUPKT_PIN_Decrypt(int a_Keymanagement, int a_EncryptMode, string a_KSN, string a_Key, string a_PAN, string a_EncipheredPin)
        {
            if (a_KSN.Length == 0 || a_Key.Length == 0 || a_PAN.Length == 0 || a_EncipheredPin.Length == 0)
            {
                return "";
            }
            string strDeciperedPin = "";
            byte[] DeciperedPin = new byte[256];
            int LenDeciperedPin = 0;
            int iLoop = 0;

            byte[] KSN = new byte[a_KSN.Length];
            for (iLoop = 0; iLoop < a_KSN.Length; iLoop++)
            {
                KSN[iLoop] = (byte)a_KSN[iLoop];
            }

            byte[] Key = new byte[a_Key.Length];
            for (iLoop = 0; iLoop < a_Key.Length; iLoop++)
            {
                Key[iLoop] = (byte)a_Key[iLoop];
            }
            byte[] PAN = new byte[a_PAN.Length];
            for (iLoop = 0; iLoop < a_PAN.Length; iLoop++)
            {
                PAN[iLoop] = (byte)a_PAN[iLoop];
            }
            byte[] EncipheredPin = new byte[a_EncipheredPin.Length];
            for (iLoop = 0; iLoop < a_EncipheredPin.Length; iLoop++)
            {
                EncipheredPin[iLoop] = (byte)a_EncipheredPin[iLoop];
            }
            Boolean bRet = AES_DUPKT_PIN_Block_Decipher(a_Keymanagement,
                                                            a_EncryptMode,
                                                            KSN,
                                                            KSN.Length,
                                                            Key,
                                                            Key.Length,
                                                            PAN,
                                                            PAN.Length,
                                                            EncipheredPin,
                                                            EncipheredPin.Length,
                                                            DeciperedPin,
                                                            ref LenDeciperedPin
                                                         );
            if (bRet)
            {
                strDeciperedPin = Common.byteToString(DeciperedPin, 0, LenDeciperedPin);
                return strDeciperedPin;
            }
            else
            {
                return "";
            }
        }

        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {
            KSN_LAB.Visible = dukpt.Checked;
            tKSNpin.Visible = dukpt.Checked;
            panel7.Visible = dukpt.Checked;
            BDKLabel.Text = "BDK";
            PANlabel.Text = "PAN";
            if (mksk.Checked)
            {
                BDKLabel.Text = "Base Key";
                PANlabel.Text = "Account";
            }
        }

        private void label18_Click(object sender, EventArgs e)
        {

        }

        private void panel5_Paint(object sender, PaintEventArgs e)
        {

        }
    }
}
